#python
from subprocess import Popen
import time
import os
#script downloads replays from
#https://content.faforever.com/replays/0/15/48/75/15487505.fafreplay
#script generates the direct link, as this is much faster than being redirected from the link without folders.
## script
#replay save directory, the scruipt automatically appends (/replays/0/15...) to it.
#this base directory must already exist
replaysirectory='fafreplay/'

#minimum replay number, keep going down until this number. number 1 is first replay.
stopreplayno=1

##if you want to resume, assuming you started from highest replay this will set start replay to lowest number you got to last time

#startreplay=maxminreoplay(replaysirectory,0)
#startreplayno=int(startreplay[:-10])

#otherwise start replay should be latest you can find in FAF vault. do not set higher than this number or wou will just be DDossing for no gain. 

startreplayno=15534465

def creeatefolderpath(number):
  #creates a string of folder path same as FAF uses to store replays
  #they do it this way because storing 15 million replays in a single folder is bad for most filesystems
  #they seperate it into 100 replays per folder
  #say input 14351408 
  #this outputs '/0/14/35/14/14351408'
  #this copuld be written much neater but works well 
  numberstr=str(number)
  numberstrrev=numberstr[::-1]
  lenstring=len(numberstr)

  dir4='0'
  dir3='0'
  dir2='0'
  dir1='0'

  #dir4
  if lenstring>2:
    dir4=numberstrrev[2]
    dir4=dir4[::-1]

  if lenstring>3:
    dir4=numberstrrev[2:4]
    dir4=dir4[::-1]

  #dir3
  if lenstring>4:
    dir3=numberstrrev[4]
    dir3=dir3[::-1]

  if lenstring>5:
    dir3=numberstrrev[4:6]
    dir3=dir3[::-1]

  #dir2
  if lenstring>6:
    dir2=numberstrrev[6]
    dir2=dir2[::-1]

  if lenstring>7:
    dir2=numberstrrev[6:8]
    dir2=dir2[::-1]

  #dir1
  if lenstring>8:
    dir1=numberstrrev[8]
    dir1=dir1[::-1]

  if lenstring>9:
    dir1=numberstrrev[8:10]
    dir1=dir1[::-1]

  filestring=dir1+'/'+dir2+'/'+dir3+'/'+dir4+'/'+numberstr
  return filestring


def getreplay(number,replaysirectory):
  #calls wget to get the replay, saves it to replay directory. 
  #Creates subdirecotries automatically with wget -X -nH. read up on wget doc for info if needed
  #but saves to ${replaysirectory}/replays/dir1/dir2/dir3/dir4/{replaynumer}.fafreplay
  filestring=creeatefolderpath(number)
  filename=filestring+'.fafreplay'
  print(filename)
  url='https://content.faforever.com/replays/'+filename
  cmd_str = 'wget -x -nH '+url+' -P '+replaysirectory
  proc = Popen([cmd_str], shell=True,stdin=None, stdout=None, stderr=None, close_fds=True)

def maxminreoplay(replaysirectory,maxmin):
  #finds the number of the maximum or minimum replay you have
  #maxmin is 0 for min replay -1 for max replay
  replaysirectory=replaysirectory+'replays/'
  dir4=sorted(os.listdir(replaysirectory))
  dir3=sorted(os.listdir(replaysirectory+'/'+dir4[maxmin]))
  dir2=sorted(os.listdir(replaysirectory+'/'+dir4[maxmin]+'/'+dir3[maxmin]))
  dir1=sorted(os.listdir(replaysirectory+'/'+dir4[maxmin]+'/'+dir3[maxmin]+'/'+dir2[maxmin]))
  replayinfolder=sorted(os.listdir(replaysirectory+'/'+dir4[maxmin]+'/'+dir3[maxmin]+'/'+dir2[maxmin]+'/'+dir1[maxmin]))
  maxminreplay=replayinfolder[maxmin]
  return maxminreplay
  #print(maxminreplay)



for number in range(startreplayno,stopreplayno,-1):
  getreplay(number,replaysirectory)
  #the sleep is to stop DDOS. Dont kill FAF replays site please. Will take ~ 17 days to download them all at this rate. 
  time.sleep(0.1)

#https://content.faforever.com/replays/0/15/48/75/15487505.fafreplay







